Subject: Re: wireless vs. alignment requirements

From: Stephen Hemminger <shemminger-de/[email-masked]>
Date: Sat, 24 Nov 2007 12:11:08 -0800

Herbert Xu wrote:
> On Sat, Nov 24, 2007 at 02:49:36PM +0100, Johannes Berg wrote:
>   
>> Right. I just didn't think that would be a valid value for an
>> architecture to set.
>>     
>
> OK.  Let me clarify this a bit more.  We require at least one
> of the following rules to be met:
>
> * the IPv4/IPv6 header is aligned by 8 bytes on reception;
> * or the platform provides unaligned exception handlers.
>
> So if your platform violates both rules then it won't work with
> the IP stack, simple as that.  Fortunately I don't think such a
> platform exists currently on Linux.
>
> Cheers,
>   

Then what about hardware that can't dma ethernet to non-aligned address.
Sky2 hardware breaks if DMA is not 8 byte aligned.  IMHO the IP stack should
handle any alignment, and do the appropriate memove if the CPU requires 
alignment.